

(defun amol/dmenu ()
(interactive)
(make-frame '((minibuffer . only)
              (name . "dmenu")
              (height . 10)
              (width . 80)))
(setq path-dirs (split-string (getenv "PATH") ":"))
(setq programs ())
(dolist (path-dir path-dirs)
  (setq path-files (directory-files path-dir t))
  (dolist (path-file path-files)
    (setq add-to-list nil)
    (setq path-file-attributes (file-attributes path-file))
    (setq file-modes (file-attribute-modes path-file-attributes))
    (setq file-uid (file-attribute-user-id path-file-attributes))
    (setq file-gid (file-attribute-group-id path-file-attributes))
    (setq user-executable (if (char-equal (elt file-modes 3) ?x) t nil))
    (setq group-executable (if (char-equal (elt file-modes 6) ?x) t nil))
    (setq other-executable (if (char-equal (elt file-modes 9) ?x) t nil))
    (setq permission nil)
    (when other-executable (setq permission t))
    (when (equal file-uid (user-uid))
      (setq permission t))
    (when permission
      (push (last (split-string path-file "/")) programs)
      )))
(shell-command (ivy-read "Select program: " programs)))
